%define gitdate 20070827
%define gitrev 8ff7213f39edc1b2b8b60d6b0cc5d5f14ca1928d

Name:           pixman
Version:        0.32.9
Release:        2%{?dist}
Summary:        Pixel manipulation library

Group:          System Environment/Libraries
License:        MIT
URL:            http://cgit.freedesktop.org/pixman/
#VCS:		git:git://git.freedesktop.org/git/pixman
# To make git snapshots:
# ./make-pixman-snapshot.sh %{?gitrev}
# if no revision specified, makes a new one from HEAD.
Source0:	http://xorg.freedesktop.org/archive/individual/lib/%{name}-%{version}.tar.bz2
Source1:	make-pixman-snapshot.sh

Patch0001:      0001-configure.ac-change-the-mmi-build-option-to-march-lo.patch
Patch0002:      0002-pixman-mmx.c-optimize-function-mmx_combine_add_u.patch
Patch0003:	0003-Optimize-mmx_fetch-store_scanline_a8-and-mmx_fetch_s.patch
Patch0004:	0004-pixman-mmx.c-optimize-mmx_fetch-store_.patch
Patch0005:	0005-pixman-mmx.c-refine-mmx_combine_add_u.patch
Patch0006:      0006-Add-MSA-support-in-configure.patch
Patch0007:      0007-mips-include-msa_macros.h.patch
Patch0008:      0008-Fix-msa-can-t-be-enabled.patch
Patch0009:      0009-Optimize-combine-series-functions-with-msa.patch
Patch0010:      0010-Optimize-imp-blt-and-imp-fill-with-msa.patch
Patch0011:      0011-Optimize-function-combine_multiply_u.patch
Patch0012:      0012-pixman-mips-msa.c-optimize-msa_fetch-store_scanline_.patch
Patch0013:      0013-pixman-mmx.c-Modify-the-__m64-zero-initialization-mo.patch
Patch0014:      0014-Add-msa_macros.h-to-pixman-for-the-time-being.patch
Patch0015:      0015-Add-runtime-check-for-mmi-and-msa-in-setup_mips_acce.patch
Patch0016:      0016-Add-msa_fetch-series-optimizations.patch
Patch0017:      0017-Add-composite-series-optimizations.patch
Patch0018:      0018-Optimize-mmx_composite_add_n_8-with-msa.patch
Patch0019:      0019-Refine-runtime-check-implementation-in-function-setu.patch
Patch0020:      0020-Add-mmx_composite_add_n_8888-optimization-with-msa.patch
Patch0021:      0021-Fix-bug-in-function-mmx_composite_src_x888_8888.patch
Patch0022:      0022-Optimize-mmx_composite_src_x888_8888-for-better-perf.patch

BuildRequires:  automake autoconf libtool

%description
Pixman is a pixel manipulation library for X and cairo.

%package devel
Summary: Pixel manipulation library development package
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
Requires: pkgconfig

%description devel
Development library for pixman.


%prep
%setup -q
%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
%patch0009 -p1
%patch0010 -p1
%patch0011 -p1
%patch0012 -p1
%patch0013 -p1
%patch0014 -p1
%patch0015 -p1
%patch0016 -p1
%patch0017 -p1
%patch0018 -p1
%patch0019 -p1
%patch0020 -p1
%patch0021 -p1
%patch0022 -p1

%build
autoreconf -fiv
%configure \
%ifarch %{arm}
  --disable-arm-iwmmxt --disable-arm-iwmmxt2 \
%endif
%ifarch ppc64le
  --disable-vmx \
%endif
%ifarch %{mips}
  --disable-mips-dspr2 \
%endif
  --disable-static

make %{?_smp_mflags} V=1

%install
make install DESTDIR=$RPM_BUILD_ROOT

find %{buildroot} -type f -name "*.la" -delete

%check
make check %{?_smp_mflags} V=1 ||:

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files
%doc COPYING
%{_libdir}/libpixman-1*.so.*

%files devel
%dir %{_includedir}/pixman-1
%{_includedir}/pixman-1/pixman.h
%{_includedir}/pixman-1/pixman-version.h
%{_libdir}/libpixman-1*.so
%{_libdir}/pkgconfig/pixman-1.pc

%changelog
* Thu Jan 09 2020 Jin Bo <jinbo-hf@loongson.cn> 0.32.9-2
- Add 0015-Add-runtime-check-for-mmi-and-msa-in-setup_mips_acce.patch
- Add 0016-Add-msa_fetch-series-optimizations.patch
- Add 0017-Add-composite-series-optimizations.patch
- Add 0018-Optimize-mmx_composite_add_n_8-with-msa.patch
- Add 0019-Refine-runtime-check-implementation-in-function-setu.patch
- Add 0020-Add-mmx_composite_add_n_8888-optimization-with-msa.patch
- Add 0021-Fix-bug-in-function-mmx_composite_src_x888_8888.patch
- Add 0022-Optimize-mmx_composite_src_x888_8888-for-better-perf.patch

* Tue Dec 03 2019 Jin Bo <jinbo-hf@loongson.cn> 0.32.9
- Upgrade pixman to 0.32.9, updated the source package to pixman-0.32.9.tar.bz2.
- Add 0001-configure.ac-change-the-mmi-build-option-to-march-lo.patch
- Add 0002-pixman-mmx.c-optimize-function-mmx_combine_add_u.patch
- Add 0003-Optimize-mmx_fetch-store_scanline_a8-and-mmx_fetch_s.patch
- Add 0004-pixman-mmx.c-optimize-mmx_fetch-store_.patch
- Add 0005-pixman-mmx.c-refine-mmx_combine_add_u.patch
- Add 0006-Add-MSA-support-in-configure.patch
- Add 0007-mips-include-msa_macros.h.patch
- Add 0008-Fix-msa-can-t-be-enabled.patch
- Add 0009-Optimize-combine-series-functions-with-msa.patch
- Add 0010-Optimize-imp-blt-and-imp-fill-with-msa.patch
- Add 0011-Optimize-function-combine_multiply_u.patch
- Add 0012-pixman-mips-msa.c-optimize-msa_fetch-store_scanline_.patch
- Add 0013-pixman-mmx.c-Modify-the-__m64-zero-initialization-mo.patch
- Add 0014-Add-msa_macros.h-to-pixman-for-the-time-being.patch

* Tue Oct 30 2018 Ray Wang <wanglei@loongson.cn> 0.32.6-8.3
- Fix unaligned memory access

* Thu Oct 11 2018  Xianju Diao <xianjudiao@gmail.com> 0.32.6-8.2
- Fix build failure on Loongson3A. 
- Fix a bug for 'define MMX_PDF_SEPARABLE_BLEND_MODE (name)'.
- See Bugs:Bug fixes for separable blend modes.

* Fri May 27 2016 Heiher <r@hev.cc> 0.32.6-7
- Fix build failure.

* Thu Jul 16 2015 zhuchen <zhuchen@loongson.cn> 0.32.6-6
- opt pixman for loongson

* Tue May 26 2015 Sun haiyong <youbest@sina.com> 0.32.6-5 
- add --disable-mips-dspr2 for mips.

* Mon Nov 10 2014 Adam Jackson <ajax@redhat.com> 0.32.6-4
- Disable (broken) VMX fast paths on ppc64le for now.

* Sun Aug 17 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.32.6-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Fri Jul 11 2014 Peter Robinson <pbrobinson@fedoraproject.org> 0.32.6-2
- Enable make check but don't (currently) fail the build on failure
- Include COPYING as per packaging guidelines
- Minor spec cleanups

* Sun Jul 06 2014 Soren Sandmann <soren.sandmann@gmail.com> 0.32.6-1
- pixman 0.32.6
- drop SSSE3 patch

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.32.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Thu Nov 14 2013 Soren Sandmann <ssp@redhat.com> 0.32.0-2
- Add patch to fix SSSE3 detection

* Sun Nov 10 2013 Soren Sandmann <ssp@redhat.com> 0.32.0-1
- pixman 0.32.0

* Sat Nov 2 2013 Soren Sandmann <ssp@redhat.com> 0.31.2-1
- pixman 0.31.2

* Sun Aug 04 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.30.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Thu Jul 04 2013 Karsten Hopp <karsten@redhat.com> 0.30.0-2
- bump release and rebuild to fix dependencies on PPC

* Wed May 8 2013 Soren Sandmann <ssp@redhat.com> 0.30.0-1
- pixman 0.30.0

* Thu Feb 21 2013 Peter Robinson <pbrobinson@fedoraproject.org> 0.28.0-3
- Disable iwmmxt on ARM as it's broken b.fd.o # 55519

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.28.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Wed Nov 7 2012 Soren Sandmann <ssp@redhat.com> 0.28.0-1
- pixman 0.28.0

* Thu Oct 25 2012 Soren Sandmann <ssp@redhat.com> 0.27.4-1
- pixman 0.27.4

* Fri Aug 10 2012 Soren Sandmann <ssp@redhat.com> 0.27.2-1
- pixman 0.27.2

* Tue Jul 31 2012 Soren Sandmann <ssp@redhat.com> 0.26.2-5
- Remove openmp patch

* Mon Jul 30 2012 Adam Jackson <ajax@redhat.com> 0.26.2-4
- Disable openmp patch in RHEL for the moment

* Sat Jul 21 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.26.2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Fri Jul  6 2012 Peter Robinson <pbrobinson@fedoraproject.org> - 0.26.2-2
- run autoreconf to properly pull in gomp

* Thu Jul  5 2012 Peter Robinson <pbrobinson@fedoraproject.org> - 0.26.2-1
- update to 0.26.2
- drop upstreamed patch

* Tue Jun 26 2012 Soren Sandmann <ssp@redhat.com> - 0.26.0-4
- Add -fopenmp to CFLAGS and LDFLAGS on the make command line instead
  of in Makefile.am.

* Tue Jun 26 2012 Soren Sandmann <ssp@redhat.com> - 0.26.0-3
- Add -fopenmp to pixman-sse2.c CFLAGS

* Tue Jun 26 2012 Soren Sandmann <ssp@redhat.com> - 0.26.0-2
- Add experimental patch to use OpenMP
  If this causes your X server to misbehave, please file bugs.

* Wed May 30 2012 Soren Sandmann <ssp@redhat.com> - 0.26.0-1
- update to 0.26.0
- patch to add missing emms instructions
- reenable iwmmxt since configure should now detect if it can't built

* Tue May 15 2012 Dennis Gilmore <dennis@ausil.us> - 0.25.6-2
- rely on runtime cpu detection for arm optimisations
- disable failing to build iwmmxt

* Tue May 15 2012 Soren Sandmann <ssp@redhat.com>
- pixman 0.25.6

* Thu Mar 29 2012 Dennis Gilmore <dennis@ausil.us> 0.25.2-2
- always disable iwmmxt  and disable neon and simd unless building armv7hnl

* Mon Mar 26 2012 Soren Sandmann <ssp@redhat.com> 0.25.2-1
- pixman 0.25.2

* Thu Mar 15 2012 Adam Jackson <ajax@redhat.com> 0.24.4-1
- pixman 0.24.4

* Thu Jan 19 2012 Soren Sandmann <ssp@redhat.com> 0.24.2-1
- pixman 0.24.2

* Sat Jan 14 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.24.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Mon Nov 7 2011 Soren Sandmann <ssp@redhat.com> 0.24.0-1
- pixman 0.24.0

* Tue Oct 11 2011 Soren Sandmann <ssp@redhat.com> 0.23.6-1
- pixman 0.23.6

* Thu Oct 06 2011 Soren Sandmann <ssp@redhat.com> 0.23.4-1
- pixman 0.23.4

* Tue Jul 05 2011 Adam Jackson <ajax@redhat.com> 0.22.2-1
- pixman 0.22.2

* Tue May 3 2011 Soren Sandmann <ssp@redhat.com> - 0.22.0-1
  pixman 0.22.0

* Wed Apr 20 2011 Soren Sandmann <ssp@redhat.com> - 0.21.8-1
  pixman 0.21.8

* Thu Feb 24 2011 Soren sandmann <ssp@redhat.com> - 0.21.6-1
- pixman 0.21.6

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.20.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Thu Jan 20 2011 Soren Sandmann <ssp@redhat.com> - 0.20.2-1
- pixman 0.20.2

* Wed Oct 27 2010 Soren Sandmann <ssp@redhat.com> - 0.20.0-1
- pixman 0.20.0

* Mon Oct 25 2010 Matthias Clasen <mclasen@redhat.com> - 0.19.6-1
- Update to 0.19.6

* Mon Sep 6 2010 Soren Sandmann <ssp@redhat.com> - 0.19.2-1
- pixman 0.19.2

* Thu Apr 1 2010 Soren Sandmann <ssp@redhat.com> - 0.18.0-1
- pixman 0.18.0

* Wed Mar 17 2010 Soren Sandmann <ssp@redhat.com> - 0.17.12-1
- pixman 0.17.12

* Fri Mar 5 2010 Soren Sandmann <ssp@redhat.com> - 0.17.10-1
- pixman 0.17.10

* Thu Feb 25 2010 Soren Sandmann <ssp@redhat.com> - 0.17.8-1
- pixman 0.17.8

* Mon Jan 18 2010 Soren Sandmann <ssp@redhat.com> - 0.17.6-1
- pixman 0.17.6

* Mon Jan 18 2010 Soren Sandmann <ssp@redhat.com> - 0.17.4-1
- pixman 0.17.4

* Wed Dec 2 2009 Soren Sandmann <ssp@redhat.com> - 0.17.2-1
- pixman 0.17.2

* Mon Sep 28 2009 Soren Sandmann <ssp@redhat.com> - 0.16.2-1
- pixman 0.16.2

* Fri Aug 28 2009 Soren Sandmann <ssp@redhat.com> - 0.16.0-1
- pixman 0.16.0

* Tue Aug 11 2009 Soren Sandmann <ssp@redhat.com> - 0.15.20-1
- pixman 0.15.20

* Mon Aug 10 2009 Ville Skyttä <ville.skytta@iki.fi> - 0.15.18-3
- Use bzipped upstream tarball.
- Fix URL.

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.15.18-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Tue Jul 21 2009 Soren Sandmann <ssp@redhat.com> 0.15.18-1
- pixman 0.15.18

* Mon Jul 13 2009 Soren Sandmann <ssp@redhat.com> 0.15.16-1
- pixman 0.15.16

* Wed Jun 24 2009 Soren Sandmann <ssp@redhat.com> 0.15.14-1
- pixman 0.15.14

* Wed Jun 17 2009 Soren Sandmann <ssp@redhat.com> 0.15.12-1
- pixman 0.15.12

* Fri Jun 5 2009 Soren Sandmann <ssp@redhat.com> 0.15.10-1
- pixman 0.15.10

* Sat May 30 2009 Soren Sandmann <ssp@redhat.com> 0.15.8-1
- pixman 0.15.8

* Fri May 22 2009 Soren Sandmann <ssp@redhat.com> 0.15.6-2
- pixman 0.15.6

* Fri May 15 2009 Soren Sandmann <ssp@redhat.com> 0.15.4-1
- pixman 0.15.4

* Wed May 13 2009 Soren Sandmann <ssp@redhat.com> 0.15.2-3
- Remove patch to implement new clipping rules as it was completely broken.

* Tue May 12 2009 Soren Sandmann <ssp@redhat.com> 0.15.2-2
- Add patch to implement new clipping rules.

* Thu Apr 16 2009 Soren Sandmann <ssp@redhat.com> 0.15.2-1
- pixman 0.15.2

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.14.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Sat Feb 7 2009 Soren Sandmann <sandmann@redhat.com> 0.14.0-1
- pixman 0.14.0

* Tue Dec 16 2008 Adam Jackson <ajax@redhat.com> 0.13.2-1
- pixman 0.13.2

* Sun Dec 14 2008 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> 0.12.0-3
- Rebuild for pkgconfig provides

* Tue Nov 18 2008 Dan Williams <dcbw@redhat.com> 0.12.0-2
- Actually build with the altivec detection fix (rh #472000, #451831)

* Wed Sep 17 2008 Soren Sandmann <sandmann@redhat.com> 0.12.0-1
- Upgrade to 0.12.0. Drop stripes patch.

* Wed Sep 10 2008 Soren Sandmann <sandmann@redhat.com> 0.11.10-2
- Add patch to fix stripes in the Nautilus selection retangle.

* Sat Sep 6 2008 Soren Sandmann <sandmann@redhat.com> 0.11.10-1
- Upgrade to 0.11.10. Drop altivec patch.

* Thu Jul 17 2008 Soren Sandmann <sandmann@redhat.com> 0.11.8-1
- Upgrade to 0.11.8. Drop altivec patch.

* Wed Jun 25 2008 Soren Sandmann <sandmann@redhat.com> 0.11.6-1
- Upgrade to 0.11.6. Drop fix for leak.

* Tue Jun 17 2008 David Woodhouse <dwmw2@infradead.org> 0.11.4-3
- Fix Altivec detection breakage (#451831)

* Fri Jun 13 2008 Soren Sandmann <sandmann@redhat.com> 0.11.4-2
- Plug bad leak (cherrypicked from master)

* Mon Jun  9 2008 Soren Sandmann <sandmann@redhat.com> 0.11.4-1
- Update to 0.11.4

* Mon Jun  9 2008 Soren Sandmann <sandmann@redhat.com> 0.11.2-1
- Update to 0.11.2

* Thu Apr  3 2008 Soren Sandmann <sandmann@redhat.com> 0.10.0-1
- Update to 0.10.0

* Mon Feb 18 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 0.9.6-4
- Autorebuild for GCC 4.3

* Wed Oct 31 2007 Behdad Esfahbod <besfahbo@redhat.com> 0.9.6-3
- Third time's the charm.

* Wed Oct 31 2007 Behdad Esfahbod <besfahbo@redhat.com> 0.9.6-2
- Second try.

* Wed Oct 31 2007 Behdad Esfahbod <besfahbo@redhat.com> 0.9.6-1
- Update to 0.9.6 release.

* Wed Sep 05 2007 Adam Jackson <ajax@redhat.com> 0.9.5-1
- Update to 0.9.5 release.

* Mon Aug 27 2007 Adam Jackson <ajax@redhat.com> 0.9.0-7.20070827
- New snapshot

* Fri Aug 24 2007 Adam Jackson <ajax@redhat.com> 0.9.0-4.20070824
- New snapshot

* Wed Jul 25 2007 Jeremy Katz <katzj@redhat.com> - 0.9.0-3.20070724
- rebuild for toolchain bug

* Tue Jul 24 2007 Adam Jackson <ajax@redhat.com> 0.9.0-2.20070724
- Re-add it, %%dir is not the same as adding a dir whole.

* Tue Jul 24 2007 Adam Jackson <ajax@redhat.com> 0.9.0-1.20070724
- Remove redundant header from %%files devel.

* Fri May 18 2007 Adam Jackson <ajax@redhat.com> 0.9.0-0.20070724
- git build so I can build git X.
